Code

test-lib: Replace uses of $(expr ...) by POSIX shell features.
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10         # do not redirect again
11         ;;
12 *' --tee '*|*' --va'*)
13         mkdir -p test-results
14         BASE=test-results/$(basename "$0" .sh)
15         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16          echo $? > $BASE.exit) | tee $BASE.out
17         test "$(cat $BASE.exit)" = 0
18         exit
19         ;;
20 esac
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 VISUAL=:
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR VISUAL
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69         1|2|true)
70                 echo "* warning: Some tests will not work if GIT_TRACE" \
71                         "is set as to trace on STDERR ! *"
72                 echo "* warning: Please set GIT_TRACE to something" \
73                         "other than 1, 2 or true ! *"
74                 ;;
75 esac
77 # Each test should start with something like this, after copyright notices:
78 #
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
81 # '
82 # . ./test-lib.sh
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84                 TERM=$ORIGINAL_TERM &&
85                 export TERM &&
86                 [ -t 1 ] &&
87                 tput bold >/dev/null 2>&1 &&
88                 tput setaf 1 >/dev/null 2>&1 &&
89                 tput sgr0 >/dev/null 2>&1
90         ) &&
91         color=t
93 while test "$#" -ne 0
94 do
95         case "$1" in
96         -d|--d|--de|--deb|--debu|--debug)
97                 debug=t; shift ;;
98         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
99                 immediate=t; shift ;;
100         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
101                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
102         -h|--h|--he|--hel|--help)
103                 help=t; shift ;;
104         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
105                 verbose=t; shift ;;
106         -q|--q|--qu|--qui|--quie|--quiet)
107                 quiet=t; shift ;;
108         --no-color)
109                 color=; shift ;;
110         --no-python)
111                 # noop now...
112                 shift ;;
113         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
114                 valgrind=t; verbose=t; shift ;;
115         --tee)
116                 shift ;; # was handled already
117         *)
118                 break ;;
119         esac
120 done
122 if test -n "$color"; then
123         say_color () {
124                 (
125                 TERM=$ORIGINAL_TERM
126                 export TERM
127                 case "$1" in
128                         error) tput bold; tput setaf 1;; # bold red
129                         skip)  tput bold; tput setaf 2;; # bold green
130                         pass)  tput setaf 2;;            # green
131                         info)  tput setaf 3;;            # brown
132                         *) test -n "$quiet" && return;;
133                 esac
134                 shift
135                 printf "* %s" "$*"
136                 tput sgr0
137                 echo
138                 )
139         }
140 else
141         say_color() {
142                 test -z "$1" && test -n "$quiet" && return
143                 shift
144                 echo "* $*"
145         }
146 fi
148 error () {
149         say_color error "error: $*"
150         trap - EXIT
151         exit 1
154 say () {
155         say_color info "$*"
158 test "${test_description}" != "" ||
159 error "Test script did not set test_description."
161 if test "$help" = "t"
162 then
163         echo "$test_description"
164         exit 0
165 fi
167 exec 5>&1
168 if test "$verbose" = "t"
169 then
170         exec 4>&2 3>&1
171 else
172         exec 4>/dev/null 3>/dev/null
173 fi
175 test_failure=0
176 test_count=0
177 test_fixed=0
178 test_broken=0
179 test_success=0
181 die () {
182         echo >&5 "FATAL: Unexpected exit with code $?"
183         exit 1
186 trap 'die' EXIT
188 # The semantics of the editor variables are that of invoking
189 # sh -c "$EDITOR \"$@\"" files ...
191 # If our trash directory contains shell metacharacters, they will be
192 # interpreted if we just set $EDITOR directly, so do a little dance with
193 # environment variables to work around this.
195 # In particular, quoting isn't enough, as the path may contain the same quote
196 # that we're using.
197 test_set_editor () {
198         FAKE_EDITOR="$1"
199         export FAKE_EDITOR
200         VISUAL='"$FAKE_EDITOR"'
201         export VISUAL
204 test_tick () {
205         if test -z "${test_tick+set}"
206         then
207                 test_tick=1112911993
208         else
209                 test_tick=$(($test_tick + 60))
210         fi
211         GIT_COMMITTER_DATE="$test_tick -0700"
212         GIT_AUTHOR_DATE="$test_tick -0700"
213         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
216 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
218 # This will commit a file with the given contents and the given commit
219 # message.  It will also add a tag with <message> as name.
221 # Both <file> and <contents> default to <message>.
223 test_commit () {
224         file=${2:-"$1.t"}
225         echo "${3-$1}" > "$file" &&
226         git add "$file" &&
227         test_tick &&
228         git commit -m "$1" &&
229         git tag "$1"
232 # Call test_merge with the arguments "<message> <commit>", where <commit>
233 # can be a tag pointing to the commit-to-merge.
235 test_merge () {
236         test_tick &&
237         git merge -m "$1" "$2" &&
238         git tag "$1"
241 # You are not expected to call test_ok_ and test_failure_ directly, use
242 # the text_expect_* functions instead.
244 test_ok_ () {
245         test_count=$(($test_count + 1))
246         test_success=$(($test_success + 1))
247         say_color "" "  ok $test_count: $@"
250 test_failure_ () {
251         test_count=$(($test_count + 1))
252         test_failure=$(($test_failure + 1))
253         say_color error "FAIL $test_count: $1"
254         shift
255         echo "$@" | sed -e 's/^/        /'
256         test "$immediate" = "" || { trap - EXIT; exit 1; }
259 test_known_broken_ok_ () {
260         test_count=$(($test_count+1))
261         test_fixed=$(($test_fixed+1))
262         say_color "" "  FIXED $test_count: $@"
265 test_known_broken_failure_ () {
266         test_count=$(($test_count+1))
267         test_broken=$(($test_broken+1))
268         say_color skip "  still broken $test_count: $@"
271 test_debug () {
272         test "$debug" = "" || eval "$1"
275 test_run_ () {
276         eval >&3 2>&4 "$1"
277         eval_ret="$?"
278         return 0
281 test_skip () {
282         to_skip=
283         for skp in $GIT_SKIP_TESTS
284         do
285                 case $this_test.$(($test_count+1)) in
286                 $skp)
287                         to_skip=t
288                 esac
289         done
290         case "$to_skip" in
291         t)
292                 say_color skip >&3 "skipping test: $@"
293                 test_count=$(($test_count+1))
294                 say_color skip "skip $test_count: $1"
295                 : true
296                 ;;
297         *)
298                 false
299                 ;;
300         esac
303 test_expect_failure () {
304         test "$#" = 2 ||
305         error "bug in the test script: not 2 parameters to test-expect-failure"
306         if ! test_skip "$@"
307         then
308                 say >&3 "checking known breakage: $2"
309                 test_run_ "$2"
310                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
311                 then
312                         test_known_broken_ok_ "$1"
313                 else
314                     test_known_broken_failure_ "$1"
315                 fi
316         fi
317         echo >&3 ""
320 test_expect_success () {
321         test "$#" = 2 ||
322         error "bug in the test script: not 2 parameters to test-expect-success"
323         if ! test_skip "$@"
324         then
325                 say >&3 "expecting success: $2"
326                 test_run_ "$2"
327                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
328                 then
329                         test_ok_ "$1"
330                 else
331                         test_failure_ "$@"
332                 fi
333         fi
334         echo >&3 ""
337 test_expect_code () {
338         test "$#" = 3 ||
339         error "bug in the test script: not 3 parameters to test-expect-code"
340         if ! test_skip "$@"
341         then
342                 say >&3 "expecting exit code $1: $3"
343                 test_run_ "$3"
344                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
345                 then
346                         test_ok_ "$2"
347                 else
348                         test_failure_ "$@"
349                 fi
350         fi
351         echo >&3 ""
354 # test_external runs external test scripts that provide continuous
355 # test output about their progress, and succeeds/fails on
356 # zero/non-zero exit code.  It outputs the test output on stdout even
357 # in non-verbose mode, and announces the external script with "* run
358 # <n>: ..." before running it.  When providing relative paths, keep in
359 # mind that all scripts run in "trash directory".
360 # Usage: test_external description command arguments...
361 # Example: test_external 'Perl API' perl ../path/to/test.pl
362 test_external () {
363         test "$#" -eq 3 ||
364         error >&5 "bug in the test script: not 3 parameters to test_external"
365         descr="$1"
366         shift
367         if ! test_skip "$descr" "$@"
368         then
369                 # Announce the script to reduce confusion about the
370                 # test output that follows.
371                 say_color "" " run $(($test_count+1)): $descr ($*)"
372                 # Run command; redirect its stderr to &4 as in
373                 # test_run_, but keep its stdout on our stdout even in
374                 # non-verbose mode.
375                 "$@" 2>&4
376                 if [ "$?" = 0 ]
377                 then
378                         test_ok_ "$descr"
379                 else
380                         test_failure_ "$descr" "$@"
381                 fi
382         fi
385 # Like test_external, but in addition tests that the command generated
386 # no output on stderr.
387 test_external_without_stderr () {
388         # The temporary file has no (and must have no) security
389         # implications.
390         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
391         stderr="$tmp/git-external-stderr.$$.tmp"
392         test_external "$@" 4> "$stderr"
393         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
394         descr="no stderr: $1"
395         shift
396         say >&3 "expecting no stderr from previous command"
397         if [ ! -s "$stderr" ]; then
398                 rm "$stderr"
399                 test_ok_ "$descr"
400         else
401                 if [ "$verbose" = t ]; then
402                         output=`echo; echo Stderr is:; cat "$stderr"`
403                 else
404                         output=
405                 fi
406                 # rm first in case test_failure exits.
407                 rm "$stderr"
408                 test_failure_ "$descr" "$@" "$output"
409         fi
412 # This is not among top-level (test_expect_success | test_expect_failure)
413 # but is a prefix that can be used in the test script, like:
415 #       test_expect_success 'complain and die' '
416 #           do something &&
417 #           do something else &&
418 #           test_must_fail git checkout ../outerspace
419 #       '
421 # Writing this as "! git checkout ../outerspace" is wrong, because
422 # the failure could be due to a segv.  We want a controlled failure.
424 test_must_fail () {
425         "$@"
426         test $? -gt 0 -a $? -le 129 -o $? -gt 192
429 # test_cmp is a helper function to compare actual and expected output.
430 # You can use it like:
432 #       test_expect_success 'foo works' '
433 #               echo expected >expected &&
434 #               foo >actual &&
435 #               test_cmp expected actual
436 #       '
438 # This could be written as either "cmp" or "diff -u", but:
439 # - cmp's output is not nearly as easy to read as diff -u
440 # - not all diff versions understand "-u"
442 test_cmp() {
443         $GIT_TEST_CMP "$@"
446 # Most tests can use the created repository, but some may need to create more.
447 # Usage: test_create_repo <directory>
448 test_create_repo () {
449         test "$#" = 1 ||
450         error "bug in the test script: not 1 parameter to test-create-repo"
451         owd=`pwd`
452         repo="$1"
453         mkdir -p "$repo"
454         cd "$repo" || error "Cannot setup test environment"
455         "$GIT_EXEC_PATH/git" init "--template=$owd/../templates/blt/" >&3 2>&4 ||
456         error "cannot run git init -- have you built things yet?"
457         mv .git/hooks .git/hooks-disabled
458         cd "$owd"
461 test_done () {
462         trap - EXIT
463         test_results_dir="$TEST_DIRECTORY/test-results"
464         mkdir -p "$test_results_dir"
465         test_results_path="$test_results_dir/${0%.sh}-$$"
467         echo "total $test_count" >> $test_results_path
468         echo "success $test_success" >> $test_results_path
469         echo "fixed $test_fixed" >> $test_results_path
470         echo "broken $test_broken" >> $test_results_path
471         echo "failed $test_failure" >> $test_results_path
472         echo "" >> $test_results_path
474         if test "$test_fixed" != 0
475         then
476                 say_color pass "fixed $test_fixed known breakage(s)"
477         fi
478         if test "$test_broken" != 0
479         then
480                 say_color error "still have $test_broken known breakage(s)"
481                 msg="remaining $(($test_count-$test_broken)) test(s)"
482         else
483                 msg="$test_count test(s)"
484         fi
485         case "$test_failure" in
486         0)
487                 # We could:
488                 # cd .. && rm -fr 'trash directory'
489                 # but that means we forbid any tests that use their own
490                 # subdirectory from calling test_done without coming back
491                 # to where they started from.
492                 # The Makefile provided will clean this test area so
493                 # we will leave things as they are.
495                 say_color pass "passed all $msg"
497                 test -d "$remove_trash" &&
498                 cd "$(dirname "$remove_trash")" &&
499                 rm -rf "$(basename "$remove_trash")"
501                 exit 0 ;;
503         *)
504                 say_color error "failed $test_failure among $msg"
505                 exit 1 ;;
507         esac
510 # Test the binaries we have just built.  The tests are kept in
511 # t/ subdirectory and are run in 'trash directory' subdirectory.
512 TEST_DIRECTORY=$(pwd)
513 if test -z "$valgrind"
514 then
515         PATH=$TEST_DIRECTORY/..:$PATH
516         GIT_EXEC_PATH=$TEST_DIRECTORY/..
517 else
518         make_symlink () {
519                 test -h "$2" &&
520                 test "$1" = "$(readlink "$2")" || {
521                         # be super paranoid
522                         if mkdir "$2".lock
523                         then
524                                 rm -f "$2" &&
525                                 ln -s "$1" "$2" &&
526                                 rm -r "$2".lock
527                         else
528                                 while test -d "$2".lock
529                                 do
530                                         say "Waiting for lock on $2."
531                                         sleep 1
532                                 done
533                         fi
534                 }
535         }
537         make_valgrind_symlink () {
538                 # handle only executables
539                 test -x "$1" || return
541                 base=$(basename "$1")
542                 symlink_target=$TEST_DIRECTORY/../$base
543                 # do not override scripts
544                 if test -x "$symlink_target" &&
545                     test ! -d "$symlink_target" &&
546                     test "#!" != "$(head -c 2 < "$symlink_target")"
547                 then
548                         symlink_target=../valgrind.sh
549                 fi
550                 case "$base" in
551                 *.sh|*.perl)
552                         symlink_target=../unprocessed-script
553                 esac
554                 # create the link, or replace it if it is out of date
555                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
556         }
558         # override all git executables in TEST_DIRECTORY/..
559         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
560         mkdir -p "$GIT_VALGRIND"/bin
561         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
562         do
563                 make_valgrind_symlink $file
564         done
565         OLDIFS=$IFS
566         IFS=:
567         for path in $PATH
568         do
569                 ls "$path"/git-* 2> /dev/null |
570                 while read file
571                 do
572                         make_valgrind_symlink "$file"
573                 done
574         done
575         IFS=$OLDIFS
576         PATH=$GIT_VALGRIND/bin:$PATH
577         GIT_EXEC_PATH=$GIT_VALGRIND/bin
578         export GIT_VALGRIND
579 fi
580 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
581 unset GIT_CONFIG
582 GIT_CONFIG_NOSYSTEM=1
583 GIT_CONFIG_NOGLOBAL=1
584 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
586 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
587 export GITPERLLIB
588 test -d ../templates/blt || {
589         error "You haven't built things yet, have you?"
592 if ! test -x ../test-chmtime; then
593         echo >&2 'You need to build test-chmtime:'
594         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
595         exit 1
596 fi
598 . ../GIT-BUILD-OPTIONS
600 # Test repository
601 test="trash directory.$(basename "$0" .sh)"
602 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
603 rm -fr "$test" || {
604         trap - EXIT
605         echo >&5 "FATAL: Cannot prepare test area"
606         exit 1
609 test_create_repo "$test"
610 # Use -P to resolve symlinks in our working directory so that the cwd
611 # in subprocesses like git equals our $PWD (for pathname comparisons).
612 cd -P "$test" || exit 1
614 this_test=${0##*/}
615 this_test=${this_test%%-*}
616 for skp in $GIT_SKIP_TESTS
617 do
618         to_skip=
619         for skp in $GIT_SKIP_TESTS
620         do
621                 case "$this_test" in
622                 $skp)
623                         to_skip=t
624                 esac
625         done
626         case "$to_skip" in
627         t)
628                 say_color skip >&3 "skipping test $this_test altogether"
629                 say_color skip "skip all tests in $this_test"
630                 test_done
631         esac
632 done